<template>
  <basic-container>
    <avue-data-display :option="staticOption">
    </avue-data-display>

    <avue-crud :option="option" :table-loading="loading" :data="data" :page.sync="page" :permission="permissionList"
      :before-open="beforeOpen" v-model="form" ref="crud" @row-update="rowUpdate" @row-save="rowSave" @row-del="rowDel"
      @search-change="searchChange" @search-reset="searchReset" @selection-change="selectionChange" @current-change="currentChange"
      @size-change="sizeChange" @refresh-change="refreshChange" @on-load="onLoad" >
      <!-- <template slot="menuLeft">
        <el-button type="danger"
                   size="small"
                   icon="el-icon-delete"
                   plain
                   v-if="permission.bussinessbonusrecords_delete"
                   @click="handleDelete">删 除
        </el-button>
      </template> -->
      <template slot="menu" slot-scope="scope">
        <el-button type="success" size="small" icon="el-icon-s-promotion" plain @click="bonusDo(scope.row)">分润
        </el-button>
      </template>
    </avue-crud>
  </basic-container>
</template>

<script>
  import {
    getList,
    getDetail,
    add,
    update,
    remove,
    bonus
  } from "@/api/guosen/bussinessbonusrecords";
  import {
    getYesterdayData
  } from "@/api/guosen/bussinessbonusstatic"
  import {
    mapGetters
  } from "vuex";

  export default {
    data() {
      return {
        form: {},
        query: {},
        loading: true,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        selectionList: [],
        option: {
          height: 'auto',
          calcHeight: 30,
          tip: false,
          searchShow: true,
          searchMenuSpan: 6,
          border: true,
          index: true,
          addBtn: false,
          delBtn: false,
          editBtn: false,
          viewBtn: false,
          selection: true,
          dialogClickModal: false,
          column: [{
              label: "广告充值分润账号",
              prop: "bonusAccoutId",
              type: "select",
              dicUrl: "/api/cyzh-guosen/bussinessbonusaccout/list",
              props: {
                label: "accout",
                value: "id"
              },
              dicFormatter: (res) => {
                return res.data.records;
              },
              rules: [{
                required: true,
                message: "请输入广告充值红利账号id",
                trigger: "blur"
              }]
            },
            {
              label: "分润比例",
              prop: "rate",
              rules: [{
                required: true,
                message: "请输入分润比例",
                trigger: "blur"
              }]
            },
            {
              label: "分成金额",
              prop: "price",
              rules: [{
                required: true,
                message: "请输入分成金额",
                trigger: "blur"
              }]
            },
            {
              label: "分成状态",
              prop: "bonusStatus",
              type: "select",
              dicData: [{
                  label: "待分配",
                  value: 0
                },
                {
                  label: "分配成功",
                  value: 1
                },
                {
                  label: "分配中",
                  value: 2
                },
                {
                  label: "分配失败",
                  value: 3
                }
              ],
              rules: [{
                required: true,
                message: "请输入分成状态",
                trigger: "blur"
              }]
            },
            {
              label: "分成日期",
              prop: "bonusDate",
              search:true,
              searchRange: true,
              type: "date",
              format: "yyyy-MM-dd",
              valueFormat: "yyyy-MM-dd",
              rules: [{
                required: true,
                message: "请输入分成金额",
                trigger: "blur"
              }]
            },
          ]
        },
        staticOption: {
          span: 6,
          data: [{
              count: 1000000,
              title: '广告昨日充值',

            },

            {
              count: 5000,
              title: '服务费昨日收入 ',

            },
            {
              count: 4000,
              title: '昨日可分配利润',

            }
          ]
        },
        data: []
      };
    },
    computed: {
      ...mapGetters(["permission"]),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permission.bussinessbonusrecords_add, false),
          viewBtn: this.vaildData(this.permission.bussinessbonusrecords_view, false),
          delBtn: this.vaildData(this.permission.bussinessbonusrecords_delete, false),
          editBtn: this.vaildData(this.permission.bussinessbonusrecords_edit, false)
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      }
    },
    methods: {
      bonusDo(row,done,loading) {
          this.$alert("确定分润吗？").then(()=>{
            bonus(row).then(() => {
              this.onLoad(this.page);
              this.$message({
                type: "success",
                message: "操作成功!"
              });
              done();
            }, error => {
              loading();
              window.console.log(error);
            });
          })
      },
      rowSave(row, done, loading) {
        add(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          window.console.log(error);
        });
      },
      rowUpdate(row, index, done, loading) {
        update(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          console.log(error);
        });
      },
      rowDel(row) {
        this.$confirm("确定将选择数据删除?", {
            confirmButtonText: "确定",
            cancelButtonText: "取消",
            type: "warning"
          })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
      },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("请选择至少一条数据");
          return;
        }
        this.$confirm("确定将选择数据删除?", {
            confirmButtonText: "确定",
            cancelButtonText: "取消",
            type: "warning"
          })
          .then(() => {
            return remove(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      beforeOpen(done, type) {
        if (["edit", "view"].includes(type)) {
          getDetail(this.form.id).then(res => {
            this.form = res.data.data;
          });
        }
        done();
      },
      searchReset() {
        this.query = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        this.query = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      currentChange(currentPage) {
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize) {
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        debugger
        if( params.bonusDate != undefined){
          params.beginDate = params.bonusDate[0];
          params.endDate = params.bonusDate[1];
          params.bonusDate = undefined
        }
        var _that = this;
        this.loading = true;
        getYesterdayData().then(res => {
          _that.staticOption.data[0].count = res.data.data.totalAmt;
          _that.staticOption.data[1].count = res.data.data.serviceAmt;
          _that.staticOption.data[2].count = res.data.data.bonusAmt;
        });
        getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
          const data = res.data.data;
          this.page.total = data.total;
          this.data = data.records;
          this.loading = false;
          this.selectionClear();
        });
      }
    }
  };
</script>

<style>
</style>
